# PyLink Developer Documentation

Please note that as PyLink is still in its development phase, its APIs are subject to change.
Any documentation here is provided for reference only.

The docs are also really incomplete (contributors welcome!)

## Introduction

PyLink is an a modular, plugin-based IRC services framework. It uses swappable protocol modules and a hooks system for calling plugins, allowing them to function regardless of the IRCd used.

## Contents

- [Writing plugins for PyLink](writing-plugins.md)
- [PyLink hooks reference](hooks-reference.md)
- [Services bot API/Creating your own service bots](services-api.md)
- [Permissions API Introduction](permissions-api.md)
- [Using `utils.IRCParser()`](using-ircparser.md)

----

- [PyLink protocol module specification](pmodule-spec.md)
- [Supported named channel modes](https://raw.githack.com/GLolol/PyLink/devel/docs/modelists/channel-modes.html)
- [Supported named user modes](https://raw.githack.com/GLolol/PyLink/devel/docs/modelists/user-modes.html)

----

- [Release Process for PyLink](release-process.md)

### Future topics (not yet available)
- [Writing tests for PyLink modules](writing-tests.md)

